;------------------------------------------------------------------------------
; Source code template for A251/A51 assembler modules.
; Copyright (c) 1995-2000 KEIL Software, Inc.
;------------------------------------------------------------------------------
; Module name
;------------------------------------------------------------------------------
NAME            module_name

;------------------------------------------------------------------------------
; FONCTION:     
;
;
;------------------------------------------------------------------------------
; AUTEUR		:  C.Dupaty
; Dvelopp le 		:  03 - 07 - 08
; Dernire modif le 	:  03 - 07 - 08
;------------------------------------------------------------------------------


#include <reg517A.inc>    ; include dfinition des registres du C Infineon C515C

;------------------------------------------------------------------------------
; XDATA SEGMENT--Reserves space in external RAM--Delete this segment if not used.
;------------------------------------------------------------------------------
xdata_seg_name  SEGMENT XDATA           ; segment for XDATA RAM
                RSEG    xdata_seg_name  ; switch to this xdata segment
xdata_variable: DS      1               ; reserve 1 Bytes for xdata_variable

;------------------------------------------------------------------------------
; DATA SEGMENT--Reserves space in DATA RAM--Delete this segment if not used.
;------------------------------------------------------------------------------
data_seg_name   SEGMENT DATA            ; segment for DATA RAM.
                RSEG    data_seg_name   ; switch to this data segment
data_variable:  DS      1               ; reserve 1 Bytes for data_variable
CPT:		DS	1		; compteur de boites

;------------------------------------------------------------------------------
; IDATA SEGMENT--Reserves space in indirect DATA RAM--Delete this segment if not used.		 
;------------------------------------------------------------------------------
idata_seg_name   SEGMENT IDATA            ; segment for DATA RAM.
                 RSEG    idata_seg_name   ; switch to this data segment
idata_variable:  DS      1               ; reserve 1 Bytes for data_variable

;------------------------------------------------------------------------------
; BIT SEGMENT--Reserves space in BIT RAM--Delete segment if not used.
;------------------------------------------------------------------------------
bit_seg_name    SEGMENT BIT             ; segment for BIT RAM.
                RSEG    bit_seg_name    ; switch to this bit segment
bit_variable:   DBIT    1               ; reserve 1 Bit for bit_variable
bit_variable1:  DBIT    4               ; reserve 4 Bits for bit_variable1

;------------------------------------------------------------------------------
; Add constant (typeless) numbers here.
;------------------------------------------------------------------------------
typeless_number EQU     0DH                     ; assign 0D hex
typeless_num1   EQU     typeless_number-8       ; evaluate typeless_num1

valTH0		EQU	0FFh	; 10 bonbons par boite
valTL0		EQU	0F6h
BOITE		EQU	P2.0



;------------------------------------------------------------------------------
; -- Debugging with Monitor-51 needs                 -- NE PAS DETRUIRE		 
;------------------------------------------------------------------------------
		DSEG	AT 	0x23
RESERVE:	DS 	3		

;------------------------------------------------------------------------------
; STACK SEGMENT--Reserves space for STACK            -- NE PAS DETRUIRE		 
;------------------------------------------------------------------------------
STACK   	SEGMENT IDATA            ; Segment pour la pile 
                RSEG    STACK		 
	  	DS      32               ; Taille de la pile



;------------------------------------------------------------------------------
; Provide an LJMP to start at the reset address (address 0) in the main module.
; You may use this style for interrupt service routines.
;------------------------------------------------------------------------------

;
                CSEG    AT      0       ; absolute Segment at Address 0
                LJMP    start           ; reset location (jump to start)
		ORG	0x000B		; vecteur TIMER0 ovf
		LJMP	IT_TIMER0

;------------------------------------------------------------------------------
; CODE SEGMENT--Reserves space in CODE ROM for assembler instructions.
;------------------------------------------------------------------------------
PROG		SEGMENT CODE
        	RSEG    PROG		   ; switch to this code segment
start:  	MOV	SP,#STACK-1        

;------------------------------------------------------------------------------
; Insert your assembly program here. 
;------------------------------------------------------------------------------

; FLASH sur P2.0, BdT TIMER0 mode 1 , periode 0,5s (demi periode 250 mS)
; Bdt=500nS : comptage : 50000 pulses soit 25mS, bascule toutes les 10 interruptions.
; FFFFh-50000d=
		MOV	TMOD,#00000101b	; TIMER 0 sur mode 1 source Q/12 (BdT 500nS) CT=1
		CLR	A		; compteur de boites
		MOV	CPT,A
		MOV 	TH0,#valTH0	; recharge TIMER0
		MOV	TL0,#valTL0
		SETB	ET0		; autorise IT sur debordement TIMER0
		SETB	EAL		; autorise toutes les IT
		SETB	TR0		; run TIMER 0
		SJMP	$		; attend IT
;
IT_TIMER0:	SETB	BOITE		; impulsion sur fermeture
		CLR	BOITE
		INC	CPT		;incremente compteur 
		MOV 	TH0,#valTH0	; recharge TIMER0
		MOV	TL0,#valTL0
		CLR	TF0		; efface drapeau IT0
		RETI
;		
;------------------------------------------------------------------------------
; The END directive is ALWAYS required.
;------------------------------------------------------------------------------
                END             ; End Of File


