; tst simulateur serie
; fonctionne sur simulateur serie1
; CD 06/08
#include <reg517.inc>
TIO	equ	S0CON.1	; bit fin reception
RIO	equ	S0CON.0	; bit fin reception
stack	segment	IDATA	; pour pile S
prog	segment	code	; zone programme
pconst	segment	code	; pur constantes

	RSEG	stack
	DS	10h	; reserve 16 octets pour la pile
;
	CSEG	AT 0	; RAZ
	ljmp	start
;
	RSEG	prog
start:	mov	sp,#stack-1
	mov	TMOD,#00100000B	; Baud rate sur TIMER 1 C/T=0, mode2
	mov	TH1,#0FDH	; Auto reaload pour Q=11.059MHz et BAUD=9600
	setb	TR1		; Demarre TIMER1
	mov	S0CON,#01010000B	; mode 1, rx actif
;
	ljmp	tache
; SP emission d'un message (fin par 0)
putst:	mov	R0,#0FFh	; R0 est le pointeur de caractre
suite:	inc	R0		; caractre suivant
	mov	a,R0		; dans acc
	movc	a,@a+dptr
	jz	fin		; si acc=0 c'est finit
	call	putch		; sinon emission caractere
	sjmp	suite		; au suivant !
fin:	ret
; SP emission d'un caractre (dans acc)	
putch:	mov	S0BUF,a		; caractre dans registre de transmission
	jnb	TIO,$		; transmission termine ?
	clr	TIO		; efface drapeau
	ret
; SP test caractere reu
isch:	jnb	RIO,non	; attend caractre	
	mov	a,#0FFh		; si oui acc=FF
	ret
non:	clr	a		; si non acc=0
	ret
; SP reception caractere
getch:	clr	RIO		; efface drapeau
	mov	a,S0BUF
	ret
;
; pour test, emission du message puis echo+1
;
tache:	mov	dptr,#txt	; adresse message dans pointeur ROM
	call	putst		; emission message
repete:	call	isch		; attend reception
	jz	repete
	call 	getch		; recupre le caratre reu
	inc	a		; retourne car +1
	call 	putch			
	sjmp	repete		; boucle sans fin
; message  transmettre
	RSEG	PCONST
txt:	db	'Test communications - ECHO+1',10,13,0 
	END




